proc defchat_CHAT_JOIN {name id loc} {
    if {$::TAC(autochat) == 1} { set e 0
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            if { $::TAC(defchat,c$j) ==  $id} { set e 1; break }
            if { $::TAC(defchat,c$j) ==  $loc} { set e 1; break }
        }
        if {$e == 0} {
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            foreach k [list 0 1 2 3 4 5 6 7 8 9] {
                if { $::TAC(defchat,c$j$k) == $id } { set e 1; break }
                if { $::TAC(defchat,c$j$k) == $loc } { set e 1; break }
            }
            if {$e} {break}
        } }
        if { $e == 0 } {
            foreach j [list 1 2 3 4 5 6 7 8 9 0] {
                if { $::TAC(defchat,c$j) == "" } {
                    set ::TAC(defchat,c$j) $loc
                    tac_output "Chat c$j is now $loc."
                    return
                }
            }
            foreach j [list 0 1 2 3 4 5 6 7 8 9] {
                foreach k [list 0 1 2 3 4 5 6 7 8 9] {
                    if { $::TAC(defchat,c$j$k) == "" } {
                        set ::TAC(defchat,c$j$k) $loc
                        tac_output "Chat c$j$k is now $loc."
                        return
                    }
                }
            }
        }
    }
}

proc tac_cmd_lschat {exp line} {
    tac_output "Defined Chats"
    tac_output "---------------"
    tac_output "Last Chat: $::TAC(lastchat)"
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        if { $::TAC(defchat,c$j) != "" } {
            tac_output "Preset c$j: $::TAC(defchat,c$j)"
        }
    }
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        foreach k [list 0 1 2 3 4 5 6 7 8 9] {
            if { $::TAC(defchat,c$j$k) != "" } {
                tac_output "Preset c$j$k: $::TAC(defchat,c$j$k)"
            }
        }
    }
}

proc tac_cmd_rmchat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) *$} $line match cmd num]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {[string range $num 0 0] != "c"} { set num "c$num" }
    if { $::TAC(defchat,$num) == "" } {
        tac_output "Preset $num not defined."
    } else {
        tac_output "$::TAC(defchat,$num) (preset $num) removed from list."
        set ::TAC(defchat,$num) ""
    }
}

proc tac_cmd_mvchat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) (c?[0-9][0-9]?) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {[string range $num1 0 0] != "c"} { set num1 "c$num1" }
    if {[string range $num2 0 0] != "c"} { set num2 "c$num2" }
    set tmp $::TAC(defchat,$num2)
    set ::TAC(defchat,$num2) $::TAC(defchat,$num1)
    set ::TAC(defchat,$num1) $tmp
    if { "$::TAC(defchat,$num1)"=="" } then {
        tac_output "Preset $num1 is undefined."
    } else {
        tac_output "Preset $num1 is now $::TAC(defchat,$num1)"
    }
    if { "$::TAC(defchat,$num2)"=="" } then {
        tac_output "Preset $num2 is undefined."
    } else {
        tac_output "Preset $num2 is now $::TAC(defchat,$num2)"
    }
}

proc tac_cmd_cpchat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) (c?[0-9][0-9]?) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {[string range $num1 0 0] != "c"} { set num1 "c$num1" }
    if {[string range $num2 0 0] != "c"} { set num2 "c$num2" }
    if { "$::TAC(defchat,$num1)"=="" } then {
        tac_output "Preset $num1 is undefined."
    } else {
        set ::TAC(defchat,$num2) $::TAC(defchat,$num1)
        tac_output "Preset $num2 is now $::TAC(defchat,$num2)"
    }
}

proc tac_cmd_scdefault {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) +([a-zA-Z0-9]+) *$} $line match cmd num name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {[string range $num 0 0] != "c"} {set num "c$num"}
    set ::TAC(defchat,$num) $name
    tac_output "Preset $num is now $::TAC(defchat,$num)."
}

proc tac_cmd_scdef2 {exp line} {
    if {![regexp -- {^(c[0-9][0-9]?=[\@\#a-zA-Z0-9]+)$} $line match arg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set num [string range $arg 0 2]
    if {[string range $num 2 2] == "=" } { set num [string range $num 0 1] }
    set name [string range $arg [expr [string length $num] + 1] end]
    if {$name == "@" || $name == "#" } {
        tac_output "$::TAC(defchat,$num) (preset $num) removed from list."
        set ::TAC(defchat,$num) ""
    } elseif {[regexp -- {^[\@\#]?c[0-9][0-9]?$} $name]} {
        if { [string range $name 0 0] == "@" } { set name [string range $name 1 end] }
        if { [string range $name 0 0] == "#" } { set name [string range $name 1 end] }
        set ::TAC(defchat,$num) $::TAC(defchat,$name)
        tac_output "Preset $num is now $::TAC(defchat,$num)."
    } else {
        set ::TAC(defchat,$num) $name
        tac_output "Preset $num is now $::TAC(defchat,$num)."
    }
}

proc tac_cmd_cdefault {exp line} {
    if {![regexp -- {^(c[0-9][0-9]?) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {"$::TAC(defchat,$cmd)"==""} { 
        tac_output "Preset $cmd not defined"
        return
    }

    set id [name2id $::TAC(defchat,$cmd)]
    toc_chat_send $::NSCREENNAME $id $msg
    set ::TAC(lastchat) $::TAC(defchat,$cmd)
}

proc tac_cmd_lastchat {exp line} {
    if {![regexp -- {^(c\.) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {$::TAC(lastchat) == ""} {
        tac_output "Last chat not defined."
        return
    }
    set id [name2id $::TAC(lastchat)]
    toc_chat_send $::NSCREENNAME $id $msg
}

proc tac_cmd_autochat {exp line} {
    if {$::TAC(autochat) == 1} {
        tac_output "Autochat is now off."
        set ::TAC(autochat) 0
    } else {
        tac_output "Autochat is now on."
        set ::TAC(autochat) 1
    }
}

tac_register_cmd 0 "h" "^c\[0\-9\]\[0\-9\]\? "   tac_cmd_cdefault "  c<num> message   send message to chat num"
tac_register_cmd 0 "h" "^c\[0\-9\]\[0\-9\]\?\@$" tac_cmd_defleave "  c<num>@          leave chat num"
tac_register_cmd 0 "h" "^\@c\[0\-9\]\[0\-9\]\?$" tac_cmd_defleave "  c<num>=@         remove chat preset num"
tac_register_cmd 0 "h" "^c\[0\-9\]\[0\-9\]\?\="  tac_cmd_scdef2   "  c<num>=chat      set chat preset num"
tac_register_cmd 0 "h" "^c\\. "                  tac_cmd_lastchat "  c. message       send a message to last chat"

tac_register_cmd 1 "h" "^/hs "     tac_cmd_scdefault      "  /hs num chat     set chat preset num"
tac_register_cmd 1 "h" "^/hl$"     tac_cmd_lschat         "  /hc              list previously defined chat presets"
tac_register_cmd 1 "h" "^/hr "     tac_cmd_rmchat         "  /hr num          remove chat num"
tac_register_cmd 1 "h" "^/hm "     tac_cmd_mvchat         "  /hm num1 num2    move chat preset num1 to slot num2"
tac_register_cmd 1 "h" "^/hc "     tac_cmd_cpchat         "  /hc num1 num2    copy chat preset num1 to slot num2"
tac_register_cmd 1 "h" "^/ac$"     tac_cmd_autochat       "  /ac              toggle autochat on/off"

tac_register_cmd 2 "h" "^h:s "      tac_cmd_scdefault     "  h:s num user/id  set chat preset num"
tac_register_cmd 2 "h" "^h:l$"      tac_cmd_lschat        "  h:l              list previously defined chat presets"
tac_register_cmd 2 "h" "^h:r "      tac_cmd_rmchat        "  h:r num          remove chat num"
tac_register_cmd 2 "h" "^h:m "      tac_cmd_mvchat        "  h:m num1 num2    move chat preset num1 to slot num2"
tac_register_cmd 2 "h" "^h:c "      tac_cmd_cpchat        "  h:c num1 num2    copy chat preset num1 to slot num2"
tac_register_cmd 2 "h" "^h:a$"      tac_cmd_autochat      "  h:a              toggle autochat on/off"
tac_register_cmd 2 "h" "^h:h$"      tac_cmd_help

toc_register_func * CHAT_JOIN defchat_CHAT_JOIN

foreach j [list 0 1 2 3 4 5 6 7 8 9] {
    foreach k [list 0 1 2 3 4 5 6 7 8 9] {
        set TAC(defchat,c$j$k) ""
    }
    set TAC(defchat,c$j) ""
}
set TAC(autochat) 1
set TAC(lastchat) ""
