# managing of permit/deny lists goes here
# i have no idea if this will actually do anything

# what needs to be done is
#   list p/d users
#   remove them from list
#   change p/d mode

proc tac_cmd_permitALL {exp line} {
    set ::PDMODE 1
}

proc tac_cmd_denyALL {exp line} {
    set ::PDMODE 2
}

proc tac_cmd_permit {exp line} {
    if {![regexp -- {^([0-9a-zA-Z/:]+) ([0-9a-zA-Z]+) *$} $line match cmd name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    toc_add_permit $name
    lappend ::PERMITLIST $name
    set ::PDMODE 3
}

proc tac_cmd_deny {exp line} {
    if {![regexp -- {^([0-9a-zA-Z/:]+) ([0-9a-zA-Z]+) *$} $line match cmd name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    toc_add_deny $name
    lappend ::DENYLIST $name
    set ::PDMODE 4
}

tac_register_cmd 1 "p" "^/pa "       tac_cmd_permit          "  /pa user         add name to permit list"
tac_register_cmd 1 "p" "^/pa$"       tac_cmd_permitALL       "  /pa              permit all users"
tac_register_cmd 1 "p" "^/da "       tac_cmd_deny            "  /da user         add name to deny list"
tac_register_cmd 1 "p" "^/da$"       tac_cmd_denyALL         "  /da              deny all users"
#tac_register_cmd 1 "p" "^/pl$"       tac_cmd_pdlist          "  /pl              list permit/deny users"
#tac_register_cmd 1 "p" "^/pr "       tac_cmd_pdremove        "  /pr user         remove user from p/d list"

tac_register_cmd 2 "p" "^p:p "       tac_cmd_permit          "  p:p user         add name to permit list"
tac_register_cmd 2 "p" "^p:p$"       tac_cmd_permitALL       "  p:p              permit all users"
tac_register_cmd 2 "p" "^p:d "       tac_cmd_deny            "  p:d user         add name to deny list"
tac_register_cmd 2 "p" "^p:d$"       tac_cmd_denyALL         "  p:d              deny all users"
#tac_register_cmd 2 "p" "^p:l$"       tac_cmd_pdlist          "  p:l              list permit/deny users"
#tac_register_cmd 2 "p" "^p:r "       tac_cmd_pdremove        "  p:r user         remove user from p/d list"
tac_register_cmd 2 "p" "^p:h$"       tac_cmd_help
