proc ts {b} {
    if { $b == "b" } { set a "btime" }
    if { $b == "c" } { set a "ctime" }
    if { $b != "b" && $b != "c" } { set a "time" }
    if { $::TAC($a) || $b == "y" } {
        if { $::TAC(time12) == 12 } {
            set tmst [clock format [clock seconds] -format %I:%M:%S%p]
        } else {
            set tmst [clock format [clock seconds] -format %H:%M:%S]
        }
        return "$tmst "
    }
}

proc tac_cmd_timestamp {exp line} {
    if { $::TAC(time) == 0 } {
        set ::TAC(time) 1
        tac_output "Message timestamps now ON."
    } else {
        set ::TAC(time) 0
        tac_output "Message timestamps now OFF."
    }
}

proc tac_cmd_btimestamp {exp line} {
    if { $::TAC(btime) == 0 } {
        set ::TAC(btime) 1
        tac_output "Buddy timestamps now ON."
    } else {
        set ::TAC(btime) 0
        tac_output "Buddy timestamps now OFF."
    }
}

proc tac_cmd_ctimestamp {exp line} {
    if { $::TAC(ctime) == 0 } {
        set ::TAC(ctime) 1
        tac_output "Chat timestamps now ON."
    } else {
        set ::TAC(ctime) 0
        tac_output "Chat timestamps now OFF."
    }
}

tac_register_cmd 1 "t" "^/tm$"      tac_cmd_timestamp      "  /tm              toggle message timestamps"
tac_register_cmd 1 "t" "^/tb$"      tac_cmd_btimestamp     "  /tb              toggle buddy timestamps"
tac_register_cmd 1 "t" "^/tc$"      tac_cmd_ctimestamp     "  /tc              toggle chat timestamps"

tac_register_cmd 2 "t" "^t:m$"      tac_cmd_timestamp      "  t:m              toggle message timestamps"
tac_register_cmd 2 "t" "^t:b$"      tac_cmd_btimestamp     "  t:b              toggle buddy timestamps"
tac_register_cmd 2 "t" "^t:c$"      tac_cmd_ctimestamp     "  t:c              toggle chat timestamps"
tac_register_cmd 2 "t" "^t:h$"      tac_cmd_help

set TAC(time) 0
set TAC(btime) 0
set TAC(ctime) 0
set TAC(time12) 12
